#include <stdio.h>
#include <math.h>
#include <vector>

#define NMAX 52
#define eps 1e-7
#define real double
#define PRINT_FORMAT "%.9lf\n"
#define sqrtfunc sqrt
#define acosfunc acos
#define atan2func atan2
#define fabsfunc fabs

real li, ls, mid;
long long x[NMAX], y[NMAX], s[NMAX], tmp;
real r[NMAX], dist[NMAX][NMAX], distsq[NMAX][NMAX], ubase[NMAX][NMAX];
real pi, u2, u3, udif2, udif3, u2a, u2b, u3a, u3b, u2ap, u2bp, u3ap, u3bp;
int N, i, j, i1, i2, i3, pimult2, pimult3, oku;

int check3(int i1, int i2, int i3) {
	if (r[i1] + dist[i1][i2] <= r[i2] || fabsfunc(r[i1] + dist[i1][i2] - r[i2]) < eps)
		return 1;
	if (r[i1] + dist[i1][i3] <= r[i3] || fabsfunc(r[i1] + dist[i1][i3] - r[i3]) < eps)
		return 1;
	if (r[i2] + dist[i2][i1] <= r[i1] || fabsfunc(r[i2] + dist[i2][i1] - r[i1]) < eps)
		return 1;
	if (r[i3] + dist[i3][i1] <= r[i1] || fabsfunc(r[i3] + dist[i3][i1] - r[i1]) < eps)
		return 1;
	
	udif2 = acosfunc((r[i1] * r[i1] + distsq[i1][i2] - r[i2] * r[i2]) / (2.0 * r[i1] * dist[i1][i2]));
	udif3 = acosfunc((r[i1] * r[i1] + distsq[i1][i3] - r[i3] * r[i3]) / (2.0 * r[i1] * dist[i1][i3]));
	u2a = ubase[i1][i2] - udif2;
	u2b = ubase[i1][i2] + udif2;
	u3a = ubase[i1][i3] - udif3;
	u3b = ubase[i1][i3] + udif3;
	
	oku = 0;
	for (pimult2 = -2; pimult2 <= 2 && !oku; pimult2 += 2)
		for (pimult3 = -2; pimult3 <= 2 && !oku; pimult3 += 2) {
			u2ap = u2a + pimult2 * pi;
			u2bp = u2b + pimult2 * pi;
			u3ap = u3a + pimult3 * pi;
			u3bp = u3b + pimult3 * pi;
	
			if ((u2ap <= u3ap && u3ap <= u2bp) || (u2ap <= u3bp && u3bp <= u2bp) ||
				(u3ap <= u2ap && u2ap <= u3bp) || (u3ap <= u2bp && u2bp <= u3bp))
				oku = 1;
		}

	return oku;
}

int ok(real T) {
	for (i = 1; i <= N; i++)
		r[i] = s[i] * T;

	// Check that every 2 circles have a common intersection area.
	for (i = 1; i < N; i++)
		for (j = i + 1; j <= N; j++) {
			if (r[i] + r[j] < dist[i][j] && fabsfunc(r[i] + r[j] - dist[i][j]) >= eps)
				return 0;
		}

	// Check that every 3 circles have a common intersection area.
	for (i1 = 1; i1 <= N; i1++)
		for (i2 = i1 + 1; i2 <= N; i2++)
			for (i3 = i2 + 1; i3 <= N; i3++) {
				if (check3(i1, i2, i3))
					continue;
				if (check3(i2, i1, i3))
					continue;
				if (check3(i3, i1, i2))
					continue;
				return 0;
			}

	return 1;
}

int main() {
	pi = 2.0 * acosfunc((real) 0.0);
	
	//freopen("x.txt", "r", stdin);
	int T;
	
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &N);
		for (i = 1; i <= N; i++)
			scanf("%lld %lld %lld", &x[i], &y[i], &s[i]);

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++) {
				distsq[i][j] = (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]);
				dist[i][j] = sqrtfunc(distsq[i][j]);
			}

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				if (j != i)
					ubase[i][j] = atan2func((real) (y[j] - y[i]), (real) (x[j] - x[i]));

		li = 0.0; ls = 1.0;
		while (!ok(ls)) {
			li = ls;
			ls *= 2.0;
		}
		
		while ((ls - li) >= eps /*&& (ls - li) >= ls * eps*/) {
			mid = 0.5 * (li + ls);
			if (ok(mid))
				ls = mid;
			else
				li = mid;
		}

		printf(PRINT_FORMAT, ls);
	}

	return 0;
}
