#include <stdio.h>
#include <string.h>
#include <set>

using namespace std;

#define MOD 1000000007
#define BMAX 100011

int bit[BMAX], sbit[BMAX];

void ComputeBits() {
	bit[0] = sbit[0] = 0;
	bit[1] = sbit[1] = 1;
	for (int i = 2; i < BMAX; i++) {
		bit[i] = (bit[i - 1] * 2) % MOD;
		sbit[i] = (sbit[i - 1] + bit[i]) % MOD;
	}
}

#define NMAX 65536

int nzero[2 * NMAX], none[2 * NMAX];

void UpdateNum(int poz, int value, int v[]) {
	poz = NMAX + poz - 1;
	while (poz > 0) {
		v[poz] += value;
		poz >>= 1;
	}
}

int GetSum(int poz, int v[]) {
	int answer;
	poz = NMAX + poz - 1;
	answer = v[poz];
	
	while (poz > 0) {
		if ((poz & 1) == 1) {
			answer += v[poz - 1];
		}
		poz >>= 1;
	}

	return answer;
}

set<pair<int, int> > szero, sone;
set<pair<int, int> >::iterator it;
pair<int, int> p;
char ptype[2 * NMAX];
int N, M, m, k, k2, bmax, i, j, error, dif, tzero, tone, vmin, vmax;

int main() {
	ComputeBits();

	//freopen("x.txt", "r", stdin);
	int T;
	
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &N);
		memset(nzero, 0, sizeof(nzero));
		memset(none, 0, sizeof(none));

		szero.clear();
		sone.clear();
		
		M = N / 2;
		bmax = error = 0;
		vmin = vmax = 0;

		for (m = 1; m <= M; m++)
			ptype[m] = -1;
		
		for (m = 1; m <= M; m++) {
			scanf("%d %d", &i, &j);

			if (error) {
				printf("-1\n");
				continue;
			}

			if (i > bmax)
				bmax = i;
			p.first = i; p.second = j;

			if (j <= M) {
				// zero.
				ptype[i] = 0;
				
				k = 0; dif = j;
				if (szero.size() > 0) {
					it = szero.lower_bound(p);
					if (it != szero.end() && it->second < j) {
						error = 1;
						printf("-1\n");
						continue;
					}
					
					if (it != szero.begin()) {
						it--;
						if (it->second > j) {
							error = 1;
							printf("-1\n");
							continue;
						}
						k = it->first;
						dif = j - it->second;
					}
				}
				
				k2 = 0;
				it = sone.lower_bound(p);
				if (it != sone.begin()) {
					it--;
					k2 = it->first;
				}
				
				if (k2 <= k) {
					tzero = dif;
					tone = i - k - dif;
				} else if (k2 > 0) {
					tzero = GetSum(k2, nzero);
					if (k > 0)
						tzero -= GetSum(k, nzero);
					tzero = dif - tzero;
					tone = i - k2 - tzero;
				}
				
				//fprintf(stderr, "zero: i=%d j=%d k=%d dif=%d k2=%d tzero=%d tone=%d\n", i, j, k, dif, k2, tzero, tone);

				if (tzero <= 0 || tone < 0) {
					error = 1;
					printf("-1\n");
					continue;
				}
				
				k = 0;
				it = szero.lower_bound(p);
				if (it != szero.end())
					k = it->first;
				it = sone.lower_bound(p);
				if (it != sone.end() && (k == 0 || it->first < k))
					k = it->first;
				
				if (k > 0) {
					//fprintf(stderr, "  before: k=%d (%d) %d %d (%d %d)\n", k, ptype[k], nzero[NMAX + k - 1], none[NMAX + k - 1], vmin, vmax);

					if (ptype[k] == 1) {
						vmin = (vmin - sbit[N - 1 - k + none[NMAX + k - 1]] + MOD) % MOD;
						vmin = (vmin + sbit[N - 1 - k]) % MOD;
						vmax = (vmax - bit[N - k] + MOD) % MOD;
						vmax = (vmax - sbit[N - k + nzero[NMAX + k - 1] + none[NMAX + k - 1] - 1] + MOD) % MOD;
						vmax = (vmax + sbit[N - k + nzero[NMAX + k - 1]]) % MOD;
					} else {
						vmin = (vmin - sbit[N - k + none[NMAX + k - 1]] + MOD) % MOD;
						vmin = (vmin + sbit[N - k]) % MOD;
						vmax = (vmax - sbit[N - 1 - k + nzero[NMAX + k - 1] + none[NMAX + k - 1]] + MOD) % MOD;
						vmax = (vmax + sbit[N - 1 - k + nzero[NMAX + k - 1]]) % MOD;
					}

					UpdateNum(k, -tzero, nzero);
					UpdateNum(k, -tone, none);
				
					if (nzero[NMAX + k - 1] < 0 || none[NMAX + k - 1] < 0 ||
						(nzero[NMAX + k - 1] == 0 && ptype[k] == 0) ||
						(none[NMAX + k - 1] == 0 && ptype[k] == 1)) {
						error = 1;
						printf("-1\n");
						continue;
					}

					//fprintf(stderr, "  after 1: k=%d %d %d (%d %d)\n", k, nzero[NMAX + k - 1], none[NMAX + k - 1], vmin, vmax);
						
					if (ptype[k] == 1) {
						vmin = (vmin + sbit[N - 1 - k + none[NMAX + k - 1]]) % MOD;
						vmin = (vmin - sbit[N - 1 - k] + MOD) % MOD;
						vmax = (vmax + bit[N - k]) % MOD;
						vmax = (vmax + sbit[N - k + nzero[NMAX + k - 1] + none[NMAX + k - 1] - 1]) % MOD;
						vmax = (vmax - sbit[N - k + nzero[NMAX + k - 1]] + MOD) % MOD;
					} else {
						vmin = (vmin + sbit[N - k + none[NMAX + k - 1]]) % MOD;
						vmin = (vmin - sbit[N - k] + MOD) % MOD;
						vmax = (vmax + sbit[N - 1 - k + nzero[NMAX + k - 1] + none[NMAX + k - 1]]) % MOD;
						vmax = (vmax - sbit[N - 1 - k + nzero[NMAX + k - 1]] + MOD) % MOD;
					}

					//fprintf(stderr, "  after 2: k=%d %d %d (%d %d)\n", k, nzero[NMAX + k - 1], none[NMAX + k - 1], vmin, vmax);
				}

				szero.insert(p);
				UpdateNum(i, tzero, nzero);
				UpdateNum(i, tone, none);

				vmin = (vmin + sbit[N - i + tone]) % MOD;
				vmin = (vmin - sbit[N - i] + MOD) % MOD;
				vmax = (vmax + sbit[N - 1 - i + tzero + tone]) % MOD;
				vmax = (vmax - sbit[N - 1 - i + tzero] + MOD) % MOD;
			} else {
				// one.
				ptype[i] = 1;

				k = 0; dif = N + 1 - j;
				if (sone.size() > 0) {
					it = sone.lower_bound(p);
					if (it != sone.end() && it->second > j) {
						error = 1;
						printf("-1\n");
						continue;
					}
					
					if (it != sone.begin()) {
						it--;
						if (it->second < j) {
							error = 1;
							printf("-1\n");
							continue;
						}
						k = it->first;
						dif = it->second - j;
					}
				}

				k2 = 0;
				it = szero.lower_bound(p);
				if (it != szero.begin()) {
					it--;
					k2 = it->first;
				}
				
				if (k2 <= k) {
					tone = dif;
					tzero = i - k - dif;
				} else if (k2 > 0) {
					tone = GetSum(k2, none);
					if (k > 0)
						tone -= GetSum(k, none);
					tone = dif - tone;
					tzero = i - k2 - tone;
				}
				
				//fprintf(stderr, "one: i=%d j=%d k=%d dif=%d k2=%d tzero=%d tone=%d\n", i, j, k, dif, k2, tzero, tone);

				if (tone <= 0 || tzero < 0) {
					error = 1;
					printf("-1\n");
					continue;
				}

				k = 0;
				it = szero.lower_bound(p);
				if (it != szero.end())
					k = it->first;
				it = sone.lower_bound(p);
				if (it != sone.end() && (k == 0 || it->first < k))
					k = it->first;
				
				if (k > 0) {
					//fprintf(stderr, "  before: k=%d (%d) %d %d (%d %d)\n", k, ptype[k], nzero[NMAX + k - 1], none[NMAX + k - 1], vmin, vmax);

					if (ptype[k] == 1) {
						vmin = (vmin - sbit[N - 1 - k + none[NMAX + k - 1]] + MOD) % MOD;
						vmin = (vmin + sbit[N - 1 - k]) % MOD;
						vmax = (vmax - bit[N - k] + MOD) % MOD;
						vmax = (vmax - sbit[N - k + nzero[NMAX + k - 1] + none[NMAX + k - 1] - 1] + MOD) % MOD;
						vmax = (vmax + sbit[N - k + nzero[NMAX + k - 1]]) % MOD;
					} else {
						vmin = (vmin - sbit[N - k + none[NMAX + k - 1]] + MOD) % MOD;
						vmin = (vmin + sbit[N - k]) % MOD;
						vmax = (vmax - sbit[N - 1 - k + nzero[NMAX + k - 1] + none[NMAX + k - 1]] + MOD) % MOD;
						vmax = (vmax + sbit[N - 1 - k + nzero[NMAX + k - 1]]) % MOD;
					}

					UpdateNum(k, -tzero, nzero);
					UpdateNum(k, -tone, none);
				
					if (nzero[NMAX + k - 1] < 0 || none[NMAX + k - 1] < 0 ||
						(nzero[NMAX + k - 1] == 0 && ptype[k] == 0) ||
						(none[NMAX + k - 1] == 0 && ptype[k] == 1)) {
						error = 1;
						printf("-1\n");
						continue;
					}

					//fprintf(stderr, "  after 1: k=%d %d %d (%d %d)\n", k, nzero[NMAX + k - 1], none[NMAX + k - 1], vmin, vmax);
						
					if (ptype[k] == 1) {
						vmin = (vmin + sbit[N - 1 - k + none[NMAX + k - 1]]) % MOD;
						vmin = (vmin - sbit[N - 1 - k] + MOD) % MOD;
						vmax = (vmax + bit[N - k]) % MOD;
						vmax = (vmax + sbit[N - k + nzero[NMAX + k - 1] + none[NMAX + k - 1] - 1]) % MOD;
						vmax = (vmax - sbit[N - k + nzero[NMAX + k - 1]] + MOD) % MOD;
					} else {
						vmin = (vmin + sbit[N - k + none[NMAX + k - 1]]) % MOD;
						vmin = (vmin - sbit[N - k] + MOD) % MOD;
						vmax = (vmax + sbit[N - 1 - k + nzero[NMAX + k - 1] + none[NMAX + k - 1]]) % MOD;
						vmax = (vmax - sbit[N - 1 - k + nzero[NMAX + k - 1]] + MOD) % MOD;
					}

					//fprintf(stderr, "  after 2: k=%d %d %d (%d %d)\n", k, nzero[NMAX + k - 1], none[NMAX + k - 1], vmin, vmax);
				}
				
				sone.insert(p);
				UpdateNum(i, tzero, nzero);
				UpdateNum(i, tone, none);			
				
				vmin = (vmin + sbit[N - 1 - i + tone]) % MOD;
				vmin = (vmin - sbit[N - 1 - i] + MOD) % MOD;
				vmax = (vmax + bit[N - i]) % MOD;
				vmax = (vmax + sbit[N - i + tzero + tone - 1]) % MOD;
				vmax = (vmax - sbit[N - i + tzero] + MOD) % MOD;
			}
			
			printf("%d %d\n", vmin, (vmax + sbit[N - 1 - bmax]) % MOD);
		}
	}
	
	return 0;
}
