#include <stdio.h>
#include <string.h>

#define NMAX 101

int dist[NMAX][NMAX], q[3 * NMAX], qli, qls;
int flow[NMAX][3 * NMAX], cap[NMAX][3 * NMAX], parent[3 * NMAX], tip[3 * NMAX], pflow[3 * NMAX];
char used[3 * NMAX], visited[3 * NMAX];
int N, M, K, C, i, j, li, ls, mid, answer, dmax, maxflow;

int ok(int Tmax) {
	//fprintf(stderr, "Testing Tmax=%d\n", Tmax);

	// Construct the graph.
	memset(flow, 0, sizeof(flow));
	memset(used, 0, sizeof(used));
	memset(pflow, 0, sizeof(pflow));

	for (i = 1; i <= N; i++)
		for (j = 1; j <= M; j++) {
			if (dist[i][j] <= Tmax)
				cap[i][N + 2 * j - 1] = 1;
			else
				cap[i][N + 2 * j - 1] = 0;
			if (dist[i][j] <= Tmax - C)
				cap[i][N + 2 * j] = 1;
			else
				cap[i][N + 2 * j] = 0;
		}
	
	// Compute a maximum matching in this graph (N nodes on the left side, 2*M nodes on the right side).
	maxflow = 0;

	while (1) {
		qli = 0;
		qls = -1;
		
		memset(visited, 0, sizeof(visited));
		for (i = 1; i <= N; i++)
			if (!used[i]) {
				visited[i] = 1;
				qls++;
				q[qls] = i;
				parent[i] = 0;
				tip[i] = 1;
			}

		while (qli <= qls) {
			i = q[qli];
			qli++;
			
			if (i <= N) {
				for (j = N + 1; j <= N + 2 * M; j++)
					if (flow[i][j] < cap[i][j] && !visited[j]) {
						visited[j] = 1;
						parent[j] = i;
						tip[j] = 1;
						qls++;
						q[qls] = j;
					}
			} else {
				if (pflow[i] > 0 && !visited[pflow[i]]) {
					visited[pflow[i]] = 1;
					parent[pflow[i]] = i;
					tip[pflow[i]] = 2;
					qls++;
					q[qls] = pflow[i];
				}
			}
		}
		
		for (i = N + 1; i <= N + 2 * M; i++)
			if (!used[i] && visited[i])
				break;
		
		if (i > N + 2 * M)
			break;

		maxflow++;

		if (maxflow == K)
			return 1;
		
		used[i] = 1;
		while (i > 0) {
			if (parent[i] == 0) {
				used[i] = 1;
			} else if (tip[i] == 1) {
				flow[parent[i]][i]++;
				pflow[i] = parent[i];
			} else {
				flow[i][parent[i]]--;
			}
			i = parent[i];
		}
	}

	return 0;
}

int main() {
	//freopen("x.txt", "r", stdin);
	int T;
	
	scanf("%d", &T);
	while (T--) {
		scanf("%d %d %d %d", &N, &M, &K, &C);
		
		dmax = 0;
		for (i = 1; i <= N; i++)
			for (j = 1; j <= M; j++) {
				scanf("%d", &dist[i][j]);
				if (dist[i][j] > dmax)
					dmax = dist[i][j];
			}
			
		li = 0; ls = answer = dmax + C;
		while (li <= ls) {
			mid = (li + ls) >> 1;
			if (ok(mid)) {
				answer = mid;
				ls = mid - 1;
			} else {
				li = mid + 1;
			}
		}
		
		printf("%d\n", answer);
	}
	
	return 0;
}
