#include <stdio.h>
#include <vector>

using namespace std;

#define NMAX 100100

vector<int> vec[NMAX];
char visited[NMAX], dead[NMAX];
int q[NMAX], ndead[NMAX];
int N, M, i, j, k, li, ls;
double ffact[NMAX], answer;

int main() {
	//freopen("x.txt", "r", stdin);
	int T;
	
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &N);
		for (i = 1; i <= N; i++) {
			vec[i].clear();
			visited[i] = dead[i] = 0;
		}
		
		for (k = 1; k < N; k++) {
			scanf("%d %d", &i, &j);
			vec[i].push_back(j);
			vec[j].push_back(i);
		}
		
		scanf("%d", &M);
		for (k = 1; k <= M; k++) {
			scanf("%d", &i);
			dead[i] = 1;
		}
		
		q[li = ls = 1] = 1;
		visited[1] = 1;
		ndead[1] = dead[1];

		while (li <= ls) {
			i = q[li];
			li++;
			
			for (k = 0; k < vec[i].size(); k++) {
				j = vec[i][k];
				if (!visited[j]) {
					visited[j] = 1;
					ndead[j] = ndead[i] + dead[j];
					ls++;
					q[ls] = j;
				}
			}
		}
		
		// Precompute numbers of the form K!/(K+1)!
		ffact[1] = 0.5;
		for (i = 2; i < N; i++) {
			ffact[i] = (ffact[i - 1] * i) / (double) (i + 1);
		}

		answer = 0.0;
		for (i = 1; i <= N; i++) {
			ndead[i] -= dead[i];
			//fprintf(stderr, "i=%d ndead=%d\n", i, ndead[i]);
			if (ndead[i] > 0)
				answer += (1.0 - ffact[ndead[i]]);
		}
		
		printf("%.9lf\n", answer);
	}
	
	return 0;
}
