#include <stdio.h>
#include <string.h>

#define MAX_NODES 600
#define KMAX 20
#define MOD 1000000007
#define NMAX 401

char marked[MAX_NODES];
int pali[KMAX], next[MAX_NODES][2], pnext[MAX_NODES][2], parent[MAX_NODES], parent_dir[MAX_NODES], pref[MAX_NODES];
int cnt[NMAX][MAX_NODES], q[MAX_NODES], li, ls;
int N, K, i, j, k, d, node, nnodes, answer;

void GenPali(int poz, int L) {
	if (poz > L) {
		for (node = i = 1; i <= L; i++) {
			if (!next[node][pali[i]]) {
				nnodes++;
				next[node][pali[i]] = nnodes;
				parent[nnodes] = node;
				parent_dir[nnodes] = pali[i];
			}
			node = next[node][pali[i]];
		}
		
		marked[node] = 1;
	} else if (poz <= (L + 1) / 2) {
		pali[poz] = 0;
		GenPali(poz + 1, L);
		pali[poz] = 1;
		GenPali(poz + 1, L);
	} else {
		pali[poz] = pali[L - poz + 1];
		GenPali(poz + 1, L);
	}
}

int main() {
	//freopen("x.txt", "r", stdin);
	int T;
	
	scanf("%d", &T);
	while (T--) {
		scanf("%d %d", &N, &K);

		memset(next, 0, sizeof(next));
		memset(marked, 0, sizeof(marked));
		nnodes = 1;

		GenPali(1, K);
		GenPali(1, K + 1);

		//fprintf(stderr, "K=%d nnodes=%d\n", K, nnodes);
		
		// Compute the maximum prefix-suffix of each node.
		q[li = ls = 1] = 1;
		while (li <= ls) {
			node = q[li];
			li++;
			for (i = 0; i <= 1; i++)
				if (next[node][i] > 0) {
					ls++;
					q[ls] = next[node][i];
				}
		}
		
		pref[1] = 1;
		for (i = 0; i <= 1; i++)
			if (next[1][i] > 0)
				pnext[1][i] = next[1][i];
			else
				pnext[1][i] = 1;
		
		for (li = 2; li <= nnodes; li++) {
			node = q[li];
			if (parent[node] == 1)
				pref[node] = 1;
			else
				pref[node] = pnext[pref[parent[node]]][parent_dir[node]];
			//fprintf(stderr, "li=%d node=%d parent=%d parent_dir=%d pref=%d\n", li, node, parent[node], parent_dir[node], pref[node]);

			for (i = 0; i <= 1; i++) {
				if (next[node][i] > 0)
					pnext[node][i] = next[node][i];
				else
					pnext[node][i] = pnext[pref[node]][i];
			}
		}
		
		memset(cnt[0], 0, sizeof(cnt[0]));
		cnt[0][1] = 1;
		
		for (i = 0; i < N; i++) {
			memset(cnt[i + 1], 0, sizeof(cnt[i + 1]));
			for (j = 1; j <= nnodes; j++)
				if (cnt[i][j] > 0) {
					//fprintf(stderr, "i=%d j=%d: cnt=%d\n", i, j, cnt[i][j]);					
					for (d = 0; d <= 1; d++) {
						k = pnext[j][d];						
						if (!marked[k])
							cnt[i + 1][k] = (cnt[i + 1][k] + cnt[i][j]) % MOD;
					}
				}
		}

		answer = 0;
		for (j = 1; j <= nnodes; j++)
			answer = (answer + cnt[N][j]) % MOD;
		printf("%d\n", answer);
	}
	
	return 0;
}
