#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <vector>

using namespace std;

#define NMAX 262144

stack<int> stk[2 * NMAX + 1];
map<int, int> ycoord_map;
set<int> ycoord;
set<int>::iterator it;
vector<pair<int, int> > v;
int xa[NMAX], ya[NMAX], xb[NMAX], yb[NMAX], ans[NMAX];
int N, i, k, cnt, c1, c2;

int Query(int c) {
	int x, answer = -1;
	c = NMAX + c - 1;
	
	while (c > 0) {
		if (stk[c].size() > 0) {
			x = stk[c].top();
			if (x > answer)
				answer = x;
		}
		c >>= 1;
	}

	if (answer >= 0)
		answer = v[answer].second - 1;
	return answer;
}

void Update(int c1, int c2, int op, int node, int lnode, int rnode) {
	if (c1 <= lnode && rnode <= c2) {
		if (op >= 0) {
			stk[node].push(op);
		} else {
			stk[node].pop();
		}
		return;
	}
	
	int lson = node << 1;
	int rson = lson + 1;
	int midnode = (lnode + rnode) >> 1;
	
	if (c1 <= midnode && c2 >= lnode)
		Update(c1, c2, op, lson, lnode, midnode);
	if (c2 > midnode && c1 <= rnode)
		Update(c1, c2, op, rson, midnode + 1, rnode);
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++) {
		scanf("%d %d %d %d", &xa[i], &ya[i], &xb[i], &yb[i]);
		v.push_back(make_pair(xa[i], i));
		v.push_back(make_pair(xb[i], -i));
		ycoord.insert(ya[i]);
		ycoord.insert(yb[i]);
	}

	cnt = 0;
	for (it = ycoord.begin(); it != ycoord.end(); it++) {
		cnt++;
		ycoord_map[*it] = cnt;
	}
	
	sort(v.begin(), v.end());

	for (i = 0; i < v.size(); i++) {
		k = v[i].second;

		if (k > 0) {
			c1 = ycoord_map[ya[k]];
			c2 = ycoord_map[yb[k]] - 1;
			ans[k] = Query(c1);			
			Update(c1, c2, i, 1, 1, NMAX);
		} else {
			k = -k;
			c1 = ycoord_map[ya[k]];
			c2 = ycoord_map[yb[k]] - 1;
			Update(c1, c2, -1, 1, 1, NMAX);
		}
	}

	for (i = 1; i <= N; i++)
		printf("%d\n", ans[i]);
	
	return 0;
}
