#include <math.h>
#include <stdio.h>
#include <string.h>

#define min(a, b) ((a) <= (b) ? (a) : (b))
#define eps 1e-7

#define NMAX 1001

int r[NMAX][NMAX];
double p[NMAX][NMAX], er[NMAX][NMAX];
int te, T, a0, b0, a, b, nreach, ncycle, len;
double pans, erans, preach, pq, erq, pcycle, spcycle;

void GetAnswer(int a, int b, int at, int bt, double *pwin, double *pt, double *erwin, int *nr, int *alast, int *blast) {
	int i, j, c, a1, b1, a2, b2, preva, prevb, sum;

	sum = a + b;
	for (i = 0; i <= sum; i++)
		for	(j = 0; j <= sum; j++) {
			r[i][j] = -1;
			p[i][j] = er[i][j] = 0.0;
		}

	p[a][b] = 1.0;
	r[a][b] = 0;
	*nr = 0;

	while (1) {
		preva = a; prevb = b;
		c = min(a, b);
		a1 = a - c; b1 = b + c;
		a2 = a + c; b2 = b - c;
		(*nr)++;

		//fprintf(stderr, "%d %d => (%d %d) (%d %d)\n", a, b, a1, b1, a2, b2);
		
		if (a1 == 0) {
			//p[a1][b1] += p[a][b] * 0.5;
			er[a1][b1] += (r[a][b] + 1) * (p[a][b] * 0.5);
		}
			
		if (b2 == 0) {
			p[a2][b2] += p[a][b] * 0.5;
			er[a2][b2] += (r[a][b] + 1) * (p[a][b] * 0.5);
		}
		
		if (a1 == 0) {
			a = a2; b = b2;
		} else {
			a = a1; b = b1;
		}
			
		if (a == 0 || b == 0)
			break;

		if (r[a][b] >= 0)
			break;
		
		if (a == at && b == bt)
			break;
			
		r[a][b] = r[preva][prevb] + 1;
		p[a][b] = p[preva][prevb] * 0.5;
	}

	*pwin = p[sum][0];
	*erwin = er[sum][0];
	
	if (sum > 0) {
		*pwin += p[0][sum];
		*erwin += er[0][sum];
	}

	*alast = a;
	*blast = b;

	if (a == at && b == bt)
		*pt = p[preva][prevb] * 0.5;
	else
		*pt = 0.0;
}

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &T);

	for (te = 1; te <= T; te++) {
//	for (a0 = 1; a0 <= 100; a0++) {
//		for (b0 = 1; b0 <= 100; b0++) {
//			te++;
		scanf("%d %d", &a0, &b0);
		GetAnswer(a0, b0, -1, -1, &pans, &pcycle, &erans, &ncycle, &a, &b);	

		if (a > 0 && b > 0) {
			GetAnswer(a0, b0, a, b, &pans, &preach, &erans, &nreach, &a, &b);
			GetAnswer(a, b, a, b, &pq, &pcycle, &erq, &ncycle, &a, &b);
			//fprintf(stderr, "a=%d b=%d: preach=%.6lf nreach=%d pans=%.6lf erans=%.6lf ncycle=%d pq=%.6lf erq=%.6lf pcycle=%.6lf\n", a, b, preach, nreach, pans, erans, ncycle, pq, erq, pcycle);

			erq = preach * (erq + (1.0 - pcycle) * nreach);
			pq *= preach;
			spcycle = (1.0 - pcycle) * preach;
			
			while (fabs(erq) > eps) {
				//fprintf(stderr, "erq=%lf\n", erq);
				pans += pq;
				erans += erq;
				pq *= pcycle;
				erq = pcycle * (erq + spcycle * ncycle);
				spcycle *= pcycle;
			}
		}

		printf("Case %d: %.6lf %.6lf\n", te, erans, pans);
	}
		
	return 0;
}
