/* Sample solution for the Doorman problem in NCPC 2012 by Tommy Färnqvist*/

import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.OutputStream;

class Kattio extends PrintWriter {
  public Kattio(InputStream i) {
    super(new BufferedOutputStream(System.out));
    r = new BufferedReader(new InputStreamReader(i));
  }
  public Kattio(InputStream i, OutputStream o) {
    super(new BufferedOutputStream(o));
    r = new BufferedReader(new InputStreamReader(i));
  }

  public boolean hasMoreTokens() {
    return peekToken() != null;
  }

  public int getInt() {
    return Integer.parseInt(nextToken());
  }

  public long getLong() {
    return Long.parseLong(nextToken());
  }

  public String getWord() {
    return nextToken();
  }

  private BufferedReader r;
  private String line;
  private StringTokenizer st;
  private String token;

  private String peekToken() {
    if (token == null)
      try {
	while (st == null || !st.hasMoreTokens()) {
	  line = r.readLine();
	  if (line == null) return null;
	  st = new StringTokenizer(line);
	}
	token = st.nextToken();
      } catch (IOException e) { }
    return token;
  }

  private String nextToken() {
    String ans = peekToken();
    token = null;
    return ans;
  }
}

public class doorman_tf {
  public static void main(String args[]) {
    Kattio io = new Kattio(System.in, System.out);

    while (io.hasMoreTokens()) {
      int x = io.getInt();
      String str = io.getWord();
      int difference = 0;
      
      for (int i = 0; i < str.length(); i++) {
	if (str.charAt(i) == 'W') {
	  difference++;
	}
	else {
	  difference--;
	}
	if (Math.abs(difference) - 1 > x) {
	  io.println((i-1));
	  io.close();
	  return;
	}
      }
      if (Math.abs(difference) - 1 == x) {
	io.println((str.length() - 1));
      }
      else {
	io.println(str.length());
      }
      io.close();
      return;
    }
  }
}
