#include <stdio.h>
#include <string.h>
#include <vector>
#include <queue>

using namespace std;

#define NMAX 1011

vector<int> vec[NMAX];
queue<int> q;
char visited[NMAX];
int dist[NMAX], p[NMAX];
int N, M, i, j, sol, clen;

void bfs(int start) {
	int i, j, k;
	
	memset(visited, 0, sizeof(visited));
	q.push(start);
	visited[start] = 1;
	dist[start] = 0;
	p[start] = 0;
	
	while (q.size() > 0) {
		i = q.front();
		q.pop();
		for (k = 0; k < vec[i].size(); k++) {
			j = vec[i][k];
			if (!visited[j]) {
				visited[j] = 1;
				p[j] = i;
				dist[j] = dist[i] + 1;
				q.push(j);
			}
		}
	}
	
	for (i = 0; i < N; i++) {
		if (!visited[i])
			continue;
		for (k = 0; k < vec[i].size(); k++) {
			j = vec[i][k];
			if (!visited[j] || p[i] == j || p[j] == i)
				continue;

			clen = dist[i] + dist[j] + 1;
			if (clen >= 3 && (sol < 0 || sol > clen)) {
				sol = clen;
			}
		}
	}
}

#define LMAX 1000

char line[LMAX];

void ReadInt(int *x) {
	int poz = 0;
	while (line[poz] < '0' || line[poz] > '9')
		poz++;
	*x = 0;
	while (line[poz] >= '0' && line[poz] <= '9') {
		*x = *x * 10 + (line[poz] - '0');
		poz++;
	}
}

void ReadTwoInts(int *x, int *y) {
	int poz = 0;
	while (line[poz] < '0' || line[poz] > '9')
		poz++;
	*x = 0;
	while (line[poz] >= '0' && line[poz] <= '9') {
		*x = *x * 10 + (line[poz] - '0');
		poz++;
	}
	while (line[poz] < '0' || line[poz] > '9')
		poz++;
	*y = 0;
	while (line[poz] >= '0' && line[poz] <= '9') {
		*y = *y * 10 + (line[poz] - '0');
		poz++;
	}
}

int main() {
	int tests, te;

	fgets(line, LMAX - 3, stdin);
	ReadInt(&tests);
	
	for (te = 1; te <= tests; te++) {
		memset(line, 0, sizeof(line));
		do {
			fgets(line, LMAX - 3, stdin);
		} while (strlen(line) < 3);
		
		ReadTwoInts(&N, &M);

		for (i = 0; i < N; i++)
			vec[i].clear();
			
		while (M--) {
			fgets(line, LMAX - 3, stdin);
			ReadTwoInts(&i, &j);
			vec[i].push_back(j);
			vec[j].push_back(i);
		}
		
		sol = -1;
		for (i = 0; i < N; i++) {
			bfs(i);
		}
		
		printf("Case %d: ", te);
		if (sol < 0)
			printf("impossible\n");
		else
			printf("%d\n", sol);
	}
	
	return 0;
}
