#include <stdio.h>
#include <stdlib.h>
#include <map>
#include <set>

using namespace std;

#define NMAX 10

set<long long> numbers[64];
set<long long>::iterator it1, it2;
map<pair<int, long long>, pair<char, pair<pair<int, long long>, pair<int, long long> > > > op;
map<pair<int, long long>, pair<char, pair<pair<int, long long>, pair<int, long long> > > >::iterator opit;

int bit[6] = { 1, 2, 4, 8, 16, 32 };
int v[NMAX];
int i, s, s1, s2, slimit;
long long T, cT, best_approx, approx_found;

void print_solution(int s, long long n) {
	opit = op.find(make_pair(s, n));
	if (opit != op.end()) {
		char cop = opit->second.first;
		pair<int, long long> p1 = opit->second.second.first;
		pair<int, long long> p2 = opit->second.second.second;
		print_solution(p1.first, p1.second);
		print_solution(p2.first, p2.second);
		printf("%lld %c %lld = %lld\n", p1.second, cop, p2.second, n);
	}
}

int main() {
	//freopen("x.txt", "r", stdin);
	int tests;
	scanf("%d", &tests);
	while (tests--) {
		for (i = 0; i < 6; i++)
			scanf("%d", &v[i]);
		scanf("%lld", &T);
		printf("Target: %lld\n", T);

		op.clear();
		
		slimit = 1 << 6;
		for (s = 1; s < slimit; s++) {			
			numbers[s].clear();

			for (i = 0; i < 6; i++)
				if ((s & bit[i]) > 0) {
					numbers[s].insert(v[i]);
				}
				
			// Try to split the set s into 2 sets.
			for (s1 = 1; s1 < slimit; s1++)
				if ((s & s1) == s1) {
					s2 = s ^ s1;
					if (s2 < s1)
						continue;
					for (it1 = numbers[s1].begin(); it1 != numbers[s1].end(); it1++) {
						long long x = *it1;
						pair<int, long long> p1 = make_pair(s1, x);
						
						for (it2 = numbers[s2].begin(); it2 != numbers[s2].end(); it2++) {
							long long y = *it2;
							pair<int, long long> p2 = make_pair(s2, y);
							long long z;
							
							z = x + y;
							if (numbers[s].find(z) == numbers[s].end()) {
								numbers[s].insert(z);
								op[make_pair(s, z)] = make_pair('+', make_pair(p1, p2));
							}

							z = x - y;
							if (z > 0 && numbers[s].find(z) == numbers[s].end()) {
								numbers[s].insert(z);
								op[make_pair(s, z)] = make_pair('-', make_pair(p1, p2));
							}

							z = y - x;
							if (z > 0 && numbers[s].find(z) == numbers[s].end()) {
								numbers[s].insert(z);
								op[make_pair(s, z)] = make_pair('-', make_pair(p2, p1));
							}

							z = x * y;
							if (numbers[s].find(z) == numbers[s].end()) {
								numbers[s].insert(z);
								op[make_pair(s, z)] = make_pair('*', make_pair(p1, p2));
							}

							if (y != 0 && (x % y == 0)) {
								z = x / y;
								if (numbers[s].find(z) == numbers[s].end()) {
									numbers[s].insert(z);
									op[make_pair(s, z)] = make_pair('/', make_pair(p1, p2));
								}
							}

							if (x != 0 && (y % x == 0)) {
								z = y / x;
								if (numbers[s].find(z) == numbers[s].end()) {
									numbers[s].insert(z);
									op[make_pair(s, z)] = make_pair('/', make_pair(p2, p1));
								}
							}
						}
					}
				}
		}
		
		approx_found = 0;
		for (it1 = numbers[63].begin(); it1 != numbers[63].end(); it1++) {
			cT = *it1;
			if (!approx_found || abs(T - cT) < abs(T - best_approx)) {
				best_approx = cT;
				approx_found = 1;
			}
		}
		
		print_solution(63, best_approx);
		printf("Best approx: %lld\n", best_approx);
		printf("\n");
	}
	
	return 0;
}
