#include <stdio.h>
#include <cstdio>
#include <string.h>

int n,m,k,solution=0;
FILE *fin,*fout;
struct dict
{
	int count;
	int index[100];
};

dict hashes[10024];
char words[10024][1001];

int hash(char*s)
{
	int hash = 0;

	for (int i=0;i<k;i++)
		    hash = s[i] + ( hash << 6 ) + ( hash << 16 ) - hash;
	for (int i= strlen(s)-k;i<strlen(s);i++)
		    hash = s[i] + ( hash << 6 ) + ( hash << 16 ) - hash;
	hash = hash & 0x7FFFFFFF;
	return hash % 10024;
}

void readHashes(){
	fscanf (fin,"%d%d",&n,&m);
	fscanf(fin,"%d",&k);
	char S[1024];
	int h;
	for (int i=0;i<n;i++)
	{
		fscanf (fin,"%s",S);
        strcpy(words[i],S);
		h = hash(S);
		hashes[h].index[hashes[h].count] = i;
		hashes[h].count++;

	}	
}

int isOk(char*s1,char*s2)
{ 
	int i,j;
	if ((s1[k]!=s2[k]) || s1[strlen(s1)-(k+1)]!=s2[strlen(s2)-(k+1)])
	{
		for (i=0;i<k;i++)
			if (s1[i]!=s2[i])
				return -1;
		i=(strlen(s1)-k);
		j=(strlen(s2)-k);
		while(i<strlen(s1) && j<strlen(s2))
		{
			if (s1[i]!=s2[j])
				return -1;
			i++;
			j++;
		}
	}
	else
		return -1;
	return 0;

		
}

void solve()
{
	for (int i=0;i<10024;i++)
		if(hashes[i].count > 1)
		{
			for (int j=0;j<hashes[i].count-1;j++)
				for(int l=j+1;l<hashes[i].count;l++)
					if(isOk(words[hashes[i].index[j]],words[hashes[i].index[l]])==0)
					{
						solution++;
						break;
					}
		}
	fprintf(fout,"%d",solution);

}

int main()
{
	
	fin = fopen("lexic.in","r");
	fout = fopen("lexic.out","w");
	readHashes();
	solve();
	fclose(stdin);
	fclose(stdout);
	return 0;
}