#include "stdio.h"
#include "stdlib.h"
#include "string.h"

//#define DEBUG_MODE

struct NodArboreBinar
{
  short inf;
  short maxDown;
  int maxPoints;
  bool viz;
  struct NodArboreBinar *st, *dr, *parinte;
};

struct ArboreBinar{
	NodArboreBinar* root;
	int N, K, S;
};

bool readFromFile(ArboreBinar* arb[11], int* nrArbori){
	FILE* f;
	char l[24000];
	char* t;
	int nrArbs, index_p;
	int count;
	ArboreBinar* a;
	NodArboreBinar* temp[4010];

	f = fopen("recoltabin.in","r");
	if(f == NULL){
		//printf("Fisier input negasit!");
		return false;
	}

	//fgets(l, sizeof(l), f);
	//nrArbs = atoi(l);
	nrArbs=1;
	(*nrArbori) = nrArbs;
	
	for(int i=0; i<nrArbs; ++i){
		a = (ArboreBinar*)malloc(sizeof(ArboreBinar));
		fgets(l, sizeof(l), f);
		t = strtok(l, " ");
		a->N = atoi(t);
		t = strtok(NULL, " ");
		a->K = atoi(t);
		t = strtok(NULL, " ");
		a->S = atoi(t);
		
		fgets(l, sizeof(l), f);
		t = strtok(l, " ");
		count = 1;
		while(t != NULL){
			temp[count] = (NodArboreBinar*)malloc(sizeof(NodArboreBinar));
			temp[count]->dr = NULL;
			temp[count]->st = NULL;
			temp[count]->inf = atoi(t);
			temp[count]->maxDown = temp[count]->inf;
			temp[count]->maxPoints = temp[count]->inf;
			temp[count]->parinte = NULL;
			temp[count]->viz = false;

			index_p = count/2;
			if(index_p > 0){
				temp[count]->parinte = temp[index_p];
				if((count&1) == 0){
					temp[index_p]->dr = temp[count];
				}else{
					temp[index_p]->st = temp[count];
				}
			}
			++count;
			t = strtok(NULL, " ");
			temp[count] = NULL;
		}
		a->root = temp[1];
		arb[i] = a;
		//printf("arb %d: N: %d, K: %d, S: %d, Root: %d\n", i, a->N, a->K, a->S, a->root);
	}
	return true;
}
bool Parcurge(NodArboreBinar* r){
	
	if(r == NULL) return false;
	Parcurge(r->st);
	Parcurge(r->dr);

	if(r->parinte == NULL) return false;

	r->parinte->maxPoints += r->maxPoints;
	if(r->parinte->maxDown < r->maxDown)	r->parinte->maxDown = r->maxDown;
	return true;
}
#ifdef DEBUG_MODE
	bool ParcurgePrint(NodArboreBinar* r){
	
		if(r == NULL) return false;

		ParcurgePrint(r->st);
		ParcurgePrint(r->dr);

		//printf("%08X, INF: %d, Points: %d, MaxDown: %d\n", r, r->inf, r->maxPoints, r->maxDown);
		return true;
	}
#endif
int ParcurgereGetMin(NodArboreBinar* r, int min){
	if(r == NULL) return min;
	if(r->viz)	return min;

	int minSt, minDr, minTmp;
	if(min > r->maxDown){ minTmp = r->maxDown; }
	else				{ minTmp = min; }

	minSt = ParcurgereGetMin(r->st, minTmp);
	minDr = ParcurgereGetMin(r->dr, minTmp);

	if(minTmp > minSt) minTmp = minSt;
	if(minTmp > minDr) minTmp = minDr;

	

	return minTmp;
}
void ParcurgereGetEligibil(NodArboreBinar* r, NodArboreBinar* n[], int* nrEligibile, int min){

	if(r == NULL) return;
	if(r->viz) return;
	if(r->maxDown == min){
		n[*nrEligibile] = r;
		++(*nrEligibile);
	}
	ParcurgereGetEligibil(r->dr, n, nrEligibile, min);
	ParcurgereGetEligibil(r->st, n, nrEligibile, min);
	return;
}

int main(){
	int				nrArbori;
	int				minPow, nrEligibile, existingNods, sumaFructe, limita;
	int				limCuts, i, j, maxPow, cArbori;
	bool			notAll;
	FILE*			f;
	char			tS[5];
	ArboreBinar*	arbori[11];
	NodArboreBinar* nods[101];
	NodArboreBinar* noduriEligibile[4010];
	NodArboreBinar* tmp;
	

	nrArbori = 0;
	readFromFile(arbori, &nrArbori);
	nrArbori = 1;
	f = fopen("recoltabin.out","w");
	if(f == NULL){
		//printf("Fisier input negasit!");
		return 1;
	}

	for(cArbori=0; cArbori<nrArbori; ++cArbori){
#ifdef DEBUG_MODE
		//printf("arb %d: N: %d, K: %d, S: %d, Root: %d\n", cArbori, arbori[cArbori]->N, arbori[cArbori]->K, arbori[cArbori]->S, arbori[cArbori]->root);
#endif
		Parcurge(arbori[cArbori]->root);
		
#ifdef DEBUG_MODE
		ParcurgePrint(arbori[cArbori]->root);
#endif
		existingNods = 0;
		sumaFructe = 0;
		limita = arbori[cArbori]->S;
		limCuts = arbori[cArbori]->K;

		while(true){
			minPow = ParcurgereGetMin(arbori[cArbori]->root, 10000001);
			//printf("MinPow: %d\n", minPow);
			
			nrEligibile = 0;
			ParcurgereGetEligibil(arbori[cArbori]->root, noduriEligibile, &nrEligibile, minPow);
		
			notAll = false;
			//sortare eligibile descrescator
			for(i=0; i<nrEligibile-1; ++i)
				for(j=1; j<nrEligibile;++j){
					if(noduriEligibile[i]->maxPoints > noduriEligibile[j]->maxPoints ){
						tmp =  noduriEligibile[i];
						noduriEligibile[i] = noduriEligibile[j];
						noduriEligibile[j] = tmp;
					}
				}

			for(i=0; i<nrEligibile; ++i){
				if(sumaFructe >= limita)	break;

				notAll = true;
				if(existingNods == limCuts){
					sumaFructe -= nods[0]->maxPoints;
					nods[0]->parinte->maxPoints += nods[0]->maxPoints;
					for(int j=0; j<existingNods-1; ++j){
						nods[j] = nods[j+1];
					}
					nods[existingNods-1] = NULL;
					--existingNods;
				}

				nods[existingNods] = noduriEligibile[i];
				nods[existingNods]->viz = true;
				nods[existingNods]->parinte->maxPoints -= nods[existingNods]->maxPoints;
				sumaFructe += nods[existingNods]->maxPoints;
				++existingNods;

				for(i=0; i<existingNods-1; ++i)
					for(j=1; j<existingNods;++j){
						if(nods[i]->maxPoints > nods[j]->maxPoints ){
							tmp =  nods[i];
							nods[i] = nods[j];
							nods[j] = tmp;
						}
				}

			}
			if(notAll){
				maxPow = minPow;
			}
#ifdef DEBUG_MODE
			for(i=0; i<existingNods; ++i){
				//printf("%d => %d => %d\n",nods[i]->inf, nods[i]->maxDown, nods[i]->maxPoints);
			}
			//printf("Suma fructe: %d, Max creanga: %d\n-----------------------------------\n", sumaFructe, maxPow);
#endif
			if(!notAll){
				//printf("Solutie!\n");
				itoa(maxPow, tS, 10);
				fputs(tS, f);
				fputs("\n",f);
				break;
			}
		
		}
	
	}
	fclose(f);
	return 0;
}

