Program Retea;
{ Clasele 10-12 }
const MAXW : longint = 510;
      MAXH : longint = 510;
      WHITE : longint = 0;
      BLACK : longint = 1;
      INFINITY : longint = 1000000;
type vertex = record
  n : longint;  { how many moves to reach this vertex }
  nedges : longint; { number of neighbouring vertices (0..6) }
  e: array[0..5] of longint;   { neighbouring vertices }
end;
     pvertex = ^vertex;
var queue: array of longint; { array[0 .. MAXW*MAXH*2 + 10] of longint }
    qpos : longint;
    i, j : longint;
    q, v, k : longint;
    maze : array of vertex; { array [0 .. MAXH*MAXW*2] of vertex }
    W, H, Sx, Sy, Fx, Fy : longint;

function other(c: longint) : longint;
begin
  Other := c xor 1;
end;

function vertexn(x, y, c : longint) : longint;
begin
    Vertexn := ((y * MAXW + x) * 2 + c);
end;

procedure addedge(v : pvertex; p : longint);
begin
    v^.e[v^.nedges] := p;
    inc(v^.nedges);
end;

procedure readdata;
var i, j, t, color : longint;
    x, y, x1, x2, y1, y2 : longint;
    buff : AnsiString;
    fin : text;
begin
  assign (fin, 'RETEA.IN');
  reset(fin);
  readln(fin, W, H);
  readln(fin, Sx,Sy,Fx,Fy);
  for j := 0 to 2*H do
  begin
    y := j div 2;
    if j mod 2 = 0
      then t := W
      else t := 2*W + 1;
    readln(fin, buff);
    for i := 0 to t-1 do
      if (buff[i+1] <> '-')
      then begin
        if (j mod 2 = 0)
        then begin { horizontal edges }
          x := i;
          x1 := x;
          x2 := x + 1;
          y2 := y;
          y1 := y;
        end
        else if (i mod 2 = 0)
        then begin { non-horizontal edges }
          x := i div 2;
          x2 := x;
          x1 := x;
          y1 := y;
          y2 := y + 1;
        end
        else begin
          x := i div 2 + 1;
          x1 := x;
          x2 := x - 1;
          y1 := y;
          y2 := y + 1;
        end;
        if buff[i+1] = 'a'
          then color := WHITE
          else color := BLACK;
        addedge(@maze[vertexn(x1, y1, other(color))],
            vertexn(x2, y2, color));
        addedge(@maze[vertexn(x2, y2, other(color))],
            vertexn(x1, y1, color));
      end;
  end;
  close(fin);
end;

procedure writedata;
  var fout : text;
begin
  assign(fout, 'RETEA.OUT');
  rewrite(fout);
  if maze[vertexn(Fx, Fy, WHITE)].n < maze[vertexn(Fx, Fy, BLACK)].n
    then writeln(fout, maze[vertexn(Fx, Fy, WHITE)].n)
    else writeln(fout, maze[vertexn(Fx, Fy, BLACK)].n);
  close(fout);
end;

procedure enqueue(p : longint);
begin
    queue[qpos] := p;
    inc(qpos);
end;

begin
  SetLength(queue, MAXW*MAXH*2 + 10);
  SetLength(maze, MAXH*MAXW*2);
  qpos := 0;
  readdata();
  for j := 0 to H do
    for i := 0 to W do
    begin
      maze[vertexn(i, j, WHITE)].n := INFINITY;
      maze[vertexn(i, j, BLACK)].n := INFINITY;
    end;
  { performing BFS }
  enqueue(vertexn(Sx, Sy, WHITE));
  enqueue(vertexn(Sx, Sy, BLACK));
  maze[vertexn(Sx, Sy, WHITE)].n := 0;
  maze[vertexn(Sx, Sy, BLACK)].n := 0;
  q := 0;
  while q < qpos do
  begin { while haven't reached the end of the queue }
    v := queue[q];
    for i := 0 to maze[v].nedges - 1 do
    begin
        k := maze[v].e[i];
        if (maze[k].n = INFINITY) then
        begin
            maze[k].n := maze[v].n + 1;
            enqueue(k);
        end;
    end;
    inc(q);
  end;
  writedata();
end.
