#include <assert.h>
#include <vector>

using namespace std;

FILE * fin = fopen ("talent.in", "r");
FILE * fout = fopen("talent.out", "w");

struct SET
{
	int s, f, a, b;
};

int n;
vector<SET> s;

int calc(SET cur, int l, int r) {
	if (cur.f < l || r < cur.s)
		return 0;

	if (l < cur.s)
		l = cur.s;
	if (r > cur.f)
		r = cur.f;
	
	int Nl = (l - cur.s) / (cur.a + cur.b);
	int Nr = (r - cur.s) / (cur.a + cur.b);

	int z = 0;

	if (Nl < Nr)
	{
		z += (Nr - Nl - 1) * cur.a;
		if (l - (cur.s + Nl * (cur.a + cur.b)) <= cur.a-1)
			z += cur.a - (l - (cur.s + Nl * (cur.a + cur.b)));

		if (r - (cur.s + Nr * (cur.a + cur.b)) <= cur.a-1)
			z += r - (cur.s + Nr * (cur.a + cur.b)) + 1;
		else
			z += cur.a;
	}
	else if (Nl == Nr) {
		l = max(cur.s + Nl * (cur.a + cur.b), l);
		r = min(cur.s + Nl * (cur.a + cur.b) + cur.a-1, r);

		if (l <= r)
			z += r - l + 1;
	}

	
	return z%2;
}

int calc (int l, int r) {
	assert(l <= r);
	int z = 0, Nl, Nr;
	for (int i = 0; i < n; ++i)
		z += calc(s[i], l, r);

	
	return z%2;
}

int main ()
{
	int i;

	fscanf(fin, "%d", &n);
	s.resize(n);
	for (i = 0; i < n; i++) {
		fscanf(fin, "%d%d%d%d", &s[i].s, &s[i].f, &s[i].a, &s[i].b);
		assert(s[i].a > 0);
		assert(s[i].b > 0);
		assert(s[i].s <= s[i].f);
	}

	int l, r, c;
	l = 0;
	r = 1000000001;

	int z = calc(l, r);
	if (z%2 == 0)
		fprintf(fout, "0\n");
	else
	{
		while (l < r) {
			c = ((double)l+(double)r) / 2.0;
			z = calc(l, c);
			if (z%2 == 0)
				l = c+1;
			else
				r = c;
		}

		assert(l == r);

		fprintf(fout, "%d\n", l);
	}

	fclose(fin);
	fclose(fout);
	return 0;
};